<?php

$show_titles = absint(get_theme_mod('p_cats_show_titles', 1));

$the_shape = absint(get_theme_mod('p_cats_shape'));
	
$shape = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAWgAAAHgAQMAAACyyGUjAAAAA1BMVEUAAACnej3aAAAAAXRSTlMAQObYZgAAACxJREFUeNrtwTEBAAAAwiD7p7bGDmAAAAAAAAAAAAAAAAAAAAAAAAAAAAAkHVZAAAFam5MDAAAAAElFTkSuQmCC'; // portrait
	
if ($the_shape == 2) {
	$shape = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAlgAAAGQAQMAAABI+4zbAAAAA1BMVEUAAACnej3aAAAAAXRSTlMAQObYZgAAADRJREFUeNrtwQENAAAAwiD7p7bHBwwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAgKQDdsAAAWZeCiIAAAAASUVORK5CYII='; // landscape
} elseif ($the_shape == 3) {
	$shape = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAfQAAAH0AQMAAADxGE3JAAAAA1BMVEUAAACnej3aAAAAAXRSTlMAQObYZgAAADVJREFUeNrtwTEBAAAAwiD7p/ZZDGAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAOX0AAAEidG8rAAAAAElFTkSuQmCC'; // square
}

$bg = pipdig_catch_that_image(get_the_ID(), 'p3_medium', 'pipdig_meta_post_image_home');

$post_location = '';
if (function_exists('rwmb_meta')) {
	$post_location = esc_html(rwmb_meta('pipdig_meta_geographic_location'));
}

?>
<div id="post-<?php the_ID(); ?>" class="col-sm-4 p_grid_post">

		<a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>" >
			
			<?php if (($wp_query->current_post > 5) && get_theme_mod('pipdig_lazy')) { ?>
				<div class="p3_cover_me nopin pipdig_lazy" data-src="<?php echo $bg; ?>">
			<?php } else { ?>
				<div class="p3_cover_me nopin" style="background-image:url(<?php echo $bg; ?>);">
			<?php } ?>
				<img src="<?php echo $shape; ?>" alt="<?php the_title_attribute(); ?>" class="p3_invisible" />
			</div>
			<?php if (!$show_titles) { ?>
			<div class="p_grid_post_overlay">
				<div class="p_grid_post_overlay_inner">
					<div class="pipdig_meta">
						<?php if (!get_theme_mod('hide_cats') && !is_category()) { ?>
							<?php echo pipdig_main_cat(false); ?>
							<?php if ($post_location) { ?>&nbsp;|&nbsp;<?php } ?>
						<?php } ?>
						<?php if ($post_location) { ?>
							<i class="pipdigicons pipdigicons-map-marker-alt"></i> <?php echo $post_location; ?>
						<?php } ?>
					</div>
					<?php the_title('<h2 class="entry-title">', '</h2>'); ?>
					<?php if (!get_theme_mod('hide_dates')) { ?>
						<div class="pipdig_meta p_grid_date" style="margin-top: 15px;">
							<?php echo get_the_date(); ?>
						</div>
					<?php } ?>
				</div>
			</div>
			<?php } ?>
		</a>
		
		<div class="p_grid_post_info">
			<div class="pipdig_meta">
				<?php if (!get_theme_mod('hide_cats') && !is_category()) { ?>
					<?php echo pipdig_main_cat(false); ?>
					<?php if ($post_location) { ?>&nbsp;|&nbsp;<?php } ?>
				<?php } ?>
				<?php if ($post_location) { ?>
					<i class="pipdigicons pipdigicons-map-marker-alt"></i> <?php echo $post_location; ?>
				<?php } ?>
			</div>
			<?php the_title('<h2 class="entry-title"><a href="'.esc_url(get_permalink()).'">', '</a></h2>'); ?>
			<?php if (!get_theme_mod('hide_dates')) { ?>
				<div class="pipdig_meta p_grid_date" style="margin-top: 15px;">
					<?php echo get_the_date(); ?>
				</div>
			<?php } ?>
		</div>
		
</div>

<?php if ($wp_query->current_post % 3 == 2) { ?>
	<div class="clearfix"></div>
<?php } ?>