<?php
/**
* Template Name: Image Gallery
*/
get_header();
wp_enqueue_script('masonry');
?>

	<div id="" class="row">
		<div class="col-xs-12 content-area nopin">
		
		<?php while ( have_posts() ) : the_post(); ?>

			<?php the_content(); ?>
			
			<?php $images = rwmb_meta( 'pipdig_meta_gallery_images', 'type=image&size=p3_medium' );	?>
		
		<?php endwhile; ?>

		<?php if (!post_password_required() && $images) { ?>
		
			<?php
			if (rwmb_meta('pipdig_meta_gallery_reverse')) {
				$images = array_reverse($images);
			}
			?>
			
			<div id="p3_gallery_masonry">
				<?php foreach ($images as $image) { ?>
				<?php
					if (!empty($image['description']) && filter_var($image['description'], FILTER_VALIDATE_URL)) {
						$link = $image['description'];
					} else {
						$link = $image['full_url'];
					}
					?>
					<div class="p3_gallery_item">
						<a href="<?php echo esc_url($link); ?>" title="<?php echo esc_attr($image['title']); ?>" data-lity>
							<img src="<?php echo esc_url($image['url']); ?>" alt="<?php echo esc_attr($image['title']); ?>" data-pin-nopin="nopin" class="skip-lazy" />
						</a>
					</div>
				<?php } ?>
			</div>
			
			<!--noptimize-->
			<script>
			jQuery(document).ready(function($) {
				var container = $("#p3_gallery_masonry");
				setTimeout(function() {
					container.masonry({
						itemSelector: ".p3_gallery_item",
					});
				}, 800);
				setInterval(function() {
					container.masonry({
						itemSelector: ".p3_gallery_item",
					});
				}, 2500);
			});
			</script>
			<!--/noptimize-->
			
		<?php } else { ?>

			No Images

		<?php } ?>

		<div class="clearfix"></div>

		</div><!-- .content-area -->
	</div>

<?php get_footer(); ?>